Index: code/trunk/src/modules/overlays/hud/HUDNavigation.cc
===================================================================
--- code/trunk/src/modules/overlays/hud/HUDNavigation.cc	(revision 6501)
+++ code/trunk/src/modules/overlays/hud/HUDNavigation.cc	(revision 6502)
@@ -153,5 +153,5 @@
         int dist = static_cast<int>(getDist2Focus());
         navText_->setCaption(multi_cast<std::string>(dist));
-        float textLength = multi_cast<std::string>(dist).size() * navText_->getCharHeight() * 0.3;
+        float textLength = multi_cast<std::string>(dist).size() * navText_->getCharHeight() * 0.3f;
 
         orxonox::Camera* cam = CameraManager::getInstance().getActiveCamera();
@@ -191,8 +191,8 @@
                 {
                     // up
-                    float position = pos.x / pos.y + 1.0;
-                    navMarker_->setPosition((position - navMarker_->getWidth()) * 0.5, 0.0);
-                    navMarker_->setUV(0.5, 0.0, 1.0, 0.5);
-                    navText_->setLeft((position - textLength) * 0.5);
+                    float position = pos.x / pos.y + 1.0f;
+                    navMarker_->setPosition((position - navMarker_->getWidth()) * 0.5f, 0.0f);
+                    navMarker_->setUV(0.5f, 0.0f, 1.0f, 0.5f);
+                    navText_->setLeft((position - textLength) * 0.5f);
                     navText_->setTop(navMarker_->getHeight());
                 }
@@ -200,9 +200,9 @@
                 {
                     // left
-                    float position = pos.y / pos.x + 1.0;
-                    navMarker_->setPosition(0.0, (position - navMarker_->getWidth()) * 0.5);
-                    navMarker_->setUV(0.0, 0.0, 0.5, 0.5);
-                    navText_->setLeft(navMarker_->getWidth() + 0.01);
-                    navText_->setTop((position - navText_->getCharHeight()) * 0.5);
+                    float position = pos.y / pos.x + 1.0f;
+                    navMarker_->setPosition(0.0f, (position - navMarker_->getWidth()) * 0.5f);
+                    navMarker_->setUV(0.0f, 0.0f, 0.5f, 0.5f);
+                    navText_->setLeft(navMarker_->getWidth() + 0.01f);
+                    navText_->setTop((position - navText_->getCharHeight()) * 0.5f);
                 }
             }
@@ -212,18 +212,18 @@
                 {
                     // down
-                    float position = -pos.x / pos.y + 1.0;
-                    navMarker_->setPosition((position - navMarker_->getWidth()) * 0.5, 1.0 - navMarker_->getHeight());
-                    navMarker_->setUV(0.0, 0.5, 0.5, 1.0);
-                    navText_->setLeft((position - textLength) * 0.5);
-                    navText_->setTop(1.0 - navMarker_->getHeight() - navText_->getCharHeight());
+                    float position = -pos.x / pos.y + 1.0f;
+                    navMarker_->setPosition((position - navMarker_->getWidth()) * 0.5f, 1.0f - navMarker_->getHeight());
+                    navMarker_->setUV(0.0f, 0.5f, 0.5f, 1.0f);
+                    navText_->setLeft((position - textLength) * 0.5f);
+                    navText_->setTop(1.0f - navMarker_->getHeight() - navText_->getCharHeight());
                 }
                 else
                 {
                     // right
-                    float position = -pos.y / pos.x + 1.0;
-                    navMarker_->setPosition(1.0 - navMarker_->getWidth(), (position - navMarker_->getHeight()) * 0.5);
-                    navMarker_->setUV(0.5, 0.5, 1.0, 1.0);
-                    navText_->setLeft(1.0 - navMarker_->getWidth() - textLength - 0.01);
-                    navText_->setTop((position - navText_->getCharHeight()) * 0.5);
+                    float position = -pos.y / pos.x + 1.0f;
+                    navMarker_->setPosition(1.0f - navMarker_->getWidth(), (position - navMarker_->getHeight()) * 0.5f);
+                    navMarker_->setUV(0.5f, 0.5f, 1.0f, 1.0f);
+                    navText_->setLeft(1.0f - navMarker_->getWidth() - textLength - 0.01f);
+                    navText_->setTop((position - navText_->getCharHeight()) * 0.5f);
                 }
             }
@@ -243,15 +243,15 @@
 
             // object is in view
-            navMarker_->setUV(0.0, 0.0, 1.0, 1.0);
-            navMarker_->setLeft((pos.x + 1.0 - navMarker_->getWidth()) * 0.5);
-            navMarker_->setTop((-pos.y + 1.0 - navMarker_->getHeight()) * 0.5);
+            navMarker_->setUV(0.0f, 0.0f, 1.0f, 1.0f);
+            navMarker_->setLeft((pos.x + 1.0f - navMarker_->getWidth()) * 0.5f);
+            navMarker_->setTop((-pos.y + 1.0f - navMarker_->getHeight()) * 0.5f);
 
 /*
             aimMarker_->show();
-            aimMarker_->setLeft((aimpos.x + 1.0 - aimMarker_->getWidth()) * 0.5);
-            aimMarker_->setTop((-aimpos.y + 1.0 - aimMarker_->getHeight()) * 0.5);
-*/
-            navText_->setLeft((pos.x + 1.0 + navMarker_->getWidth()) * 0.5);
-            navText_->setTop((-pos.y + 1.0 + navMarker_->getHeight()) * 0.5);
+            aimMarker_->setLeft((aimpos.x + 1.0f - aimMarker_->getWidth()) * 0.5f);
+            aimMarker_->setTop((-aimpos.y + 1.0f - aimMarker_->getHeight()) * 0.5f);
+*/
+            navText_->setLeft((pos.x + 1.0f + navMarker_->getWidth()) * 0.5f);
+            navText_->setTop((-pos.y + 1.0f + navMarker_->getHeight()) * 0.5f);
         }
     }
Index: code/trunk/src/modules/overlays/hud/HUDRadar.cc
===================================================================
--- code/trunk/src/modules/overlays/hud/HUDRadar.cc	(revision 6501)
+++ code/trunk/src/modules/overlays/hud/HUDRadar.cc	(revision 6502)
@@ -141,12 +141,12 @@
         // calc position on radar...
         Vector2 coord = get2DViewcoordinates(this->owner_->getPosition(), this->owner_->getOrientation() * WorldEntity::FRONT, this->owner_->getOrientation() * WorldEntity::UP, wePointer->getWorldPosition());
-        coord *= Ogre::Math::PI / 3.5; // small adjustment to make it fit the texture
-        panel->setPosition((1.0 + coord.x - size) * 0.5, (1.0 - coord.y - size) * 0.5);
+        coord *= Ogre::Math::PI / 3.5f; // small adjustment to make it fit the texture
+        panel->setPosition((1.0f + coord.x - size) * 0.5f, (1.0f - coord.y - size) * 0.5f);
 
         if (bIsMarked)
         {
             this->marker_->show();
-            this->marker_->setDimensions(size * 1.5, size * 1.5);
-            this->marker_->setPosition((1.0 + coord.x - size * 1.5) * 0.5, (1.0 - coord.y - size * 1.5) * 0.5);
+            this->marker_->setDimensions(size * 1.5f, size * 1.5f);
+            this->marker_->setPosition((1.0f + coord.x - size * 1.5f) * 0.5f, (1.0f - coord.y - size * 1.5f) * 0.5f);
         }
     }
Index: code/trunk/src/modules/overlays/stats/CreateLines.cc
===================================================================
--- code/trunk/src/modules/overlays/stats/CreateLines.cc	(revision 6501)
+++ code/trunk/src/modules/overlays/stats/CreateLines.cc	(revision 6502)
@@ -38,17 +38,17 @@
     {
         playerNameText_ = new OverlayText(0);
-        playerNameText_->setTextSize(0.04);
-        playerNameText_->setColour(ColourValue(0, 0.75, 0.2, 1));
-        playerNameText_->setPosition(Vector2(0.1, topOffset + 0.01));
+        playerNameText_->setTextSize(0.04f);
+        playerNameText_->setColour(ColourValue(0.0f, 0.75f, 0.2f, 1.0f));
+        playerNameText_->setPosition(Vector2(0.1f, topOffset + 0.01f));
 
         scoreText_ = new OverlayText(0);
-        scoreText_->setTextSize(0.04);
-        scoreText_->setColour(ColourValue(0, 0.75, 0.2, 1));
-        scoreText_->setPosition(Vector2(0.6, topOffset + 0.01));
+        scoreText_->setTextSize(0.04f);
+        scoreText_->setColour(ColourValue(0.0f, 0.75f, 0.2f, 1.0f));
+        scoreText_->setPosition(Vector2(0.6f, topOffset + 0.01f));
 
         deathsText_ = new OverlayText(0);
-        deathsText_->setTextSize(0.04);
-        deathsText_->setColour(ColourValue(0, 0.75, 0.2, 1));
-        deathsText_->setPosition(Vector2(0.8, topOffset + 0.01));
+        deathsText_->setTextSize(0.04f);
+        deathsText_->setColour(ColourValue(0, 0.75f, 0.2f, 1.0f));
+        deathsText_->setPosition(Vector2(0.8f, topOffset + 0.01f));
 
         background_ = new Stats(0);
Index: code/trunk/src/modules/overlays/stats/Scoreboard.cc
===================================================================
--- code/trunk/src/modules/overlays/stats/Scoreboard.cc	(revision 6501)
+++ code/trunk/src/modules/overlays/stats/Scoreboard.cc	(revision 6502)
@@ -79,9 +79,9 @@
         const std::map<PlayerInfo*, Player>& playerList = this->getGametype()->getPlayers();
 
-        const float topOffset  = 0.2;
-        const float leftOffset = 0.075;
-        const float distance   = 0.01;
-        const float width      = 0.85;
-        const float height     = 0.05;
+        const float topOffset  = 0.2f;
+        const float leftOffset = 0.075f;
+        const float distance   = 0.01f;
+        const float width      = 0.85f;
+        const float height     = 0.05f;
         while (playerList.size() > this->lines_.size())
         {
Index: code/trunk/src/modules/overlays/stats/Stats.cc
===================================================================
--- code/trunk/src/modules/overlays/stats/Stats.cc	(revision 6501)
+++ code/trunk/src/modules/overlays/stats/Stats.cc	(revision 6502)
@@ -59,14 +59,14 @@
         this->statsOverlayBorder_ = static_cast<Ogre::BorderPanelOverlayElement*>(ovMan->createOverlayElement("BorderPanel", "StatsBorderPanel" + getUniqueNumberString()));
         //this->statsOverlayBorder_->setMaterialName("StatsCenter");
-        this->statsOverlayBorder_->setBorderSize(0.003, 16 * 0.003);
+        this->statsOverlayBorder_->setBorderSize(0.003f, 16.0f * 0.003f);
         this->statsOverlayBorder_->setBorderMaterialName("StatsBorder");
-        this->statsOverlayBorder_->setTopBorderUV(0.49, 0.0, 0.51, 0.5);
-        this->statsOverlayBorder_->setTopLeftBorderUV(0.0, 0.0, 0.5, 0.5);
-        this->statsOverlayBorder_->setTopRightBorderUV(0.5, 0.0, 1.0, 0.5);
-        this->statsOverlayBorder_->setLeftBorderUV(0.0, 0.49, 0.5, 0.51);
-        this->statsOverlayBorder_->setRightBorderUV(0.5, 0.49, 1.0, 0.5);
-        this->statsOverlayBorder_->setBottomBorderUV(0.49, 0.5, 0.51, 1.0);
-        this->statsOverlayBorder_->setBottomLeftBorderUV(0.0, 0.5, 0.5, 1.0);
-        this->statsOverlayBorder_->setBottomRightBorderUV(0.5, 0.5, 1.0, 1.0);
+        this->statsOverlayBorder_->setTopBorderUV(0.49f, 0.0f, 0.51f, 0.5f);
+        this->statsOverlayBorder_->setTopLeftBorderUV(0.0f, 0.0f, 0.5f, 0.5f);
+        this->statsOverlayBorder_->setTopRightBorderUV(0.5f, 0.0f, 1.0f, 0.5f);
+        this->statsOverlayBorder_->setLeftBorderUV(0.0f, 0.49f, 0.5f, 0.51f);
+        this->statsOverlayBorder_->setRightBorderUV(0.5f, 0.49f, 1.0f, 0.5f);
+        this->statsOverlayBorder_->setBottomBorderUV(0.49f, 0.5f, 0.51f, 1.0f);
+        this->statsOverlayBorder_->setBottomLeftBorderUV(0.0f, 0.5f, 0.5f, 1.0f);
+        this->statsOverlayBorder_->setBottomRightBorderUV(0.5f, 0.5f, 1.0f, 1.0f);
 
         background_->addChild(statsOverlayBorder_);
Index: code/trunk/src/modules/questsystem/QuestGUINode.cc
===================================================================
--- code/trunk/src/modules/questsystem/QuestGUINode.cc	(revision 6501)
+++ code/trunk/src/modules/questsystem/QuestGUINode.cc	(revision 6502)
@@ -161,6 +161,6 @@
             const QuestDescription* description = this->item_->getDescription();
             this->details_ = this->gui_->getWindowManager()->createWindow("TaharezLook/FrameWindow", stream.str());
-            this->details_->setSize(CEGUI::UVector2(CEGUI::UDim(0.7, 0),CEGUI::UDim(0.7, 0)));
-            this->details_->setPosition(CEGUI::UVector2(CEGUI::UDim(0.1, 0),CEGUI::UDim(0.1, 0)));
+            this->details_->setSize(CEGUI::UVector2(CEGUI::UDim(0.7f, 0),CEGUI::UDim(0.7f, 0)));
+            this->details_->setPosition(CEGUI::UVector2(CEGUI::UDim(0.1f, 0),CEGUI::UDim(0.1f, 0)));
             this->details_->setText(description->getTitle());
             this->details_->setAlpha(1.0);
@@ -173,5 +173,5 @@
             CEGUI::Window* window = this->gui_->getWindowManager()->createWindow("TaharezLook/ScrollablePane", stream.str());
             window->setSize(CEGUI::UVector2(CEGUI::UDim(1.0, -2*QuestGUINode::BORDER_WIDTH),CEGUI::UDim(1.0, -QuestGUINode::TITLE_HEIGHT)));
-            window->setPosition(CEGUI::UVector2(CEGUI::UDim(0, QuestGUINode::BORDER_WIDTH),CEGUI::UDim(0, QuestGUINode::TITLE_HEIGHT)));
+            window->setPosition(CEGUI::UVector2(CEGUI::UDim(0, (float)QuestGUINode::BORDER_WIDTH),CEGUI::UDim(0, (float)QuestGUINode::TITLE_HEIGHT)));
             this->details_->addChildWindow(window);
 
@@ -203,6 +203,6 @@
                 statusWindow->setProperty("VertFormatting", "TopAligned");
                 statusWindow->setText(status);
-                statusWindow->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 0),CEGUI::UDim(0, offset)));
-                statusWindow->setSize(CEGUI::UVector2(CEGUI::UDim(1.0, -QuestGUINode::SCROLLBAR_WIDTH),CEGUI::UDim(1.0, 0)));
+                statusWindow->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 0),CEGUI::UDim(0, (float)offset)));
+                statusWindow->setSize(CEGUI::UVector2(CEGUI::UDim(1.0, (float)-QuestGUINode::SCROLLBAR_WIDTH),CEGUI::UDim(1.0f, 0)));
                 height = setHeight(statusWindow);
 
@@ -219,6 +219,6 @@
             descriptionWindowTitle->setProperty("VertFormatting", "TopAligned");
             descriptionWindowTitle->setText("Description:");
-            descriptionWindowTitle->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 0),CEGUI::UDim(0, offset)));
-            descriptionWindowTitle->setSize(CEGUI::UVector2(CEGUI::UDim(1.0, -QuestGUINode::SCROLLBAR_WIDTH),CEGUI::UDim(1.0, 0)));
+            descriptionWindowTitle->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 0),CEGUI::UDim(0, (float)offset)));
+            descriptionWindowTitle->setSize(CEGUI::UVector2(CEGUI::UDim(1.0f, -QuestGUINode::SCROLLBAR_WIDTH),CEGUI::UDim(1.0f, 0)));
 
             offset += setHeight(descriptionWindowTitle);
@@ -232,6 +232,6 @@
             descriptionWindow->setProperty("VertFormatting", "TopAligned");
             descriptionWindow->setText(description->getDescription());
-            descriptionWindow->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 0),CEGUI::UDim(0, offset)));
-            descriptionWindow->setSize(CEGUI::UVector2(CEGUI::UDim(1.0, -QuestGUINode::SCROLLBAR_WIDTH),CEGUI::UDim(1.0, 0)));
+            descriptionWindow->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 0),CEGUI::UDim(0, (float)offset)));
+            descriptionWindow->setSize(CEGUI::UVector2(CEGUI::UDim(1.0, (float)-QuestGUINode::SCROLLBAR_WIDTH),CEGUI::UDim(1.0f, 0)));
             height = setHeight(descriptionWindow);
 
@@ -255,5 +255,5 @@
                             hintsTitle->setProperty("VertFormatting", "TopAligned");
                             hintsTitle->setText("Hints:");
-                            hintsTitle->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 0),CEGUI::UDim(0, offset)));
+                            hintsTitle->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 0),CEGUI::UDim(0, (float)offset)));
                             hintsTitle->setSize(CEGUI::UVector2(CEGUI::UDim(1.0, -QuestGUINode::SCROLLBAR_WIDTH),CEGUI::UDim(1.0, 0)));
                             offset += setHeight(hintsTitle);;
@@ -261,6 +261,6 @@
                         }
                         QuestGUINode* node = *it;
-                        node->window_->setSize(CEGUI::UVector2(CEGUI::UDim(1.0, -QuestGUINode::SCROLLBAR_WIDTH),CEGUI::UDim(0, QuestGUINode::BUTTON_HEIGHT)));
-                        node->window_->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 0),CEGUI::UDim(0, offset)));
+                        node->window_->setSize(CEGUI::UVector2(CEGUI::UDim(1.0f, (float)-QuestGUINode::SCROLLBAR_WIDTH),CEGUI::UDim(0, (float)QuestGUINode::BUTTON_HEIGHT)));
+                        node->window_->setPosition(CEGUI::UVector2(CEGUI::UDim(0, 0),CEGUI::UDim(0, (float)offset)));
                         window->addChildWindow(node->window_);
                         offset += QuestGUINode::BUTTON_HEIGHT;
@@ -337,5 +337,5 @@
 
         //! Get the formatted line count - using the formatting area obtained above.
-        const float lines = window->getFont()->getFormattedLineCount(window->getText(), formattedArea, CEGUI::WordWrapLeftAligned);
+        const float lines = (float)(window->getFont()->getFormattedLineCount(window->getText(), formattedArea, CEGUI::WordWrapLeftAligned));
 
         //! Calculate pixel height of window, which is the number of formatted lines multiplied by the spacing of the font, plus the pixel height of the frame.
@@ -357,6 +357,6 @@
     void QuestGUINode::updatePosition(void)
     {
-        this->window_->setPosition(CEGUI::UVector2(CEGUI::UDim(0, QuestGUINode::INDENT_WIDTH*this->depth_),CEGUI::UDim(0, QuestGUINode::BUTTON_HEIGHT*this->index_)));
-        this->window_->setSize(CEGUI::UVector2(CEGUI::UDim(1, -QuestGUINode::INDENT_WIDTH*this->depth_-QuestGUINode::SCROLLBAR_WIDTH),CEGUI::UDim(0, QuestGUINode::BUTTON_HEIGHT)));
+        this->window_->setPosition(CEGUI::UVector2(CEGUI::UDim(0, (float)(QuestGUINode::INDENT_WIDTH*this->depth_)),CEGUI::UDim(0, (float)(QuestGUINode::BUTTON_HEIGHT*this->index_))));
+        this->window_->setSize(CEGUI::UVector2(CEGUI::UDim(1, (float)(-QuestGUINode::INDENT_WIDTH*this->depth_-QuestGUINode::SCROLLBAR_WIDTH)),CEGUI::UDim(0, (float)QuestGUINode::BUTTON_HEIGHT)));
     }
 
Index: code/trunk/src/modules/questsystem/notifications/NotificationQueue.cc
===================================================================
--- code/trunk/src/modules/questsystem/notifications/NotificationQueue.cc	(revision 6501)
+++ code/trunk/src/modules/questsystem/notifications/NotificationQueue.cc	(revision 6502)
@@ -139,9 +139,9 @@
             {
                 this->removeContainer(*it);
-                this->scroll(Vector2(0.0,-(1.1*this->getFontSize())));
+                this->scroll(Vector2(0.0f,-(1.1f*this->getFontSize())));
                 it = this->containers_.begin(); //TODO: Needed?
             }
 
-            this->tickTime_ = 0.0; //!< Reset time counter.
+            this->tickTime_ = 0.0f; //!< Reset time counter.
         }
     }
@@ -193,5 +193,5 @@
             it = this->containers_.begin();
             this->removeContainer(*it);
-            this->scroll(Vector2(0.0,-(1.1*this->getFontSize())));
+            this->scroll(Vector2(0.0f,-(1.1f*this->getFontSize())));
         }
 
@@ -375,5 +375,5 @@
         {
             (*it)->overlay->setPosition(this->getPosition());
-            (*it)->overlay->scroll(Vector2(0.0,(1.1*this->getFontSize())*counter));
+            (*it)->overlay->scroll(Vector2(0.0f,(1.1f*this->getFontSize())*counter));
             counter++;
         }
@@ -407,5 +407,5 @@
         this->size_= this->size_+1;
 
-        container->overlay->scroll(Vector2(0.0,(1.1*this->getFontSize())*(this->getSize()-1)));
+        container->overlay->scroll(Vector2(0.0f,(1.1f*this->getFontSize())*(this->getSize()-1)));
     }
 
Index: code/trunk/src/modules/weapons/projectiles/BillboardProjectile.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/BillboardProjectile.cc	(revision 6501)
+++ code/trunk/src/modules/weapons/projectiles/BillboardProjectile.cc	(revision 6502)
@@ -48,5 +48,5 @@
         }
 
-        this->setScale(0.2);
+        this->setScale(0.2f);
     }
 
Index: code/trunk/src/modules/weapons/projectiles/Rocket.cc
===================================================================
--- code/trunk/src/modules/weapons/projectiles/Rocket.cc	(revision 6501)
+++ code/trunk/src/modules/weapons/projectiles/Rocket.cc	(revision 6502)
@@ -66,5 +66,5 @@
             Model* model = new Model(this);
             model->setMeshSource("rocket.mesh");
-            model->scale(0.7);
+            model->scale(0.7f);
             this->attach(model);
             ParticleEmitter* fire = new ParticleEmitter(this);
Index: code/trunk/src/modules/weapons/weaponmodes/RocketFire.cc
===================================================================
--- code/trunk/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 6501)
+++ code/trunk/src/modules/weapons/weaponmodes/RocketFire.cc	(revision 6502)
@@ -46,5 +46,5 @@
         RegisterObject(RocketFire);
 
-        this->reloadTime_ = 0.20;
+        this->reloadTime_ = 0.20f;
         this->bParallelReload_ = false;
         this->damage_ = 100;