Index: data/branches/png/AUTHORS
===================================================================
--- data/branches/png/AUTHORS	(revision 6582)
+++ data/branches/png/AUTHORS	(revision 6612)
@@ -54,6 +54,6 @@
 gui/imagesets/DriveIcons.png                                unknown
 gui/imagesets/FairChar.imageset                             unknown
-gui/imagesets/FairChar.tga                                  unknown
-gui/imagesets/GPN-2000-001437.tga                           GRIN (http://grin.hq.nasa.gov/)
+gui/imagesets/FairChar.png                                  unknown
+gui/imagesets/GPN-2000-001437.png                           GRIN (http://grin.hq.nasa.gov/)
 gui/imagesets/Imageset.xsd                                  unknown
 gui/imagesets/MainMenuBackground.imageset                   Benjamin Knecht
@@ -61,9 +61,9 @@
 gui/imagesets/sleekspace.png                                Seth Yastrov
 gui/imagesets/TaharezLook.imageset                          unknown
-gui/imagesets/TaharezLook.tga                               Lars "Taharez" Rinde
+gui/imagesets/TaharezLook.png                               Lars "Taharez" Rinde
 gui/imagesets/Vanilla.imageset                              unknown
-gui/imagesets/vanilla.tga                                   Shane Parker
+gui/imagesets/vanilla.png                                   Shane Parker
 gui/imagesets/WindowsLook.imageset                          unknown
-gui/imagesets/WindowsLook.tga                               Paul "CrazyEddie" Turner
+gui/imagesets/WindowsLook.png                               Paul "CrazyEddie" Turner
 gui/looknfeel/Falagard.xsd                                  unknown
 gui/looknfeel/sleekspace.looknfeel                          Seth Yastrov
@@ -145,5 +145,5 @@
 materials/scripts/LightningGun.material                     Joël Smely
 materials/scripts/LightningGun-s.material                   Joël Smely
-materials/scripts/LightningGun-s.tga                        Joël Smely
+materials/scripts/LightningGun-s.png                        Joël Smely
 materials/scripts/Map.material                              Si Sun
 materials/scripts/MotionBlur.compositor                     unknown
@@ -177,12 +177,12 @@
 materials/scripts/UEATransporter036.material                Axel Bomhauer-Beins
 materials/scripts/wrench.material                           Benjamin Knecht
-materials/textures/arrows.tga                    
+materials/textures/arrows.png                    
 materials/textures/assff.JPG                     
 materials/textures/atmosphere.png                
-materials/textures/atmospheretype1.tga           
-materials/textures/atmospheretype2.tga           
-materials/textures/atmospheretype3.tga                   
-materials/textures/atmospheretype4.tga           
-materials/textures/atmospheretype5.tga           
+materials/textures/atmospheretype1.png           
+materials/textures/atmospheretype2.png           
+materials/textures/atmospheretype3.png                   
+materials/textures/atmospheretype4.png           
+materials/textures/atmospheretype5.png           
 materials/textures/babel-base2.jpg               
 materials/textures/babel-trim3b.jpg              
@@ -191,94 +191,93 @@
 materials/textures/babel-wall6a.jpg              
 materials/textures/babel-wall6b.jpg              
-materials/textures/backGround.tga                
-materials/textures/backlightflare.tga            
-materials/textures/backlighttrail.tga            
-materials/textures/bar1.tga                      
-materials/textures/bar2a.tga                     
-materials/textures/bar2b.tga                     
-materials/textures/bar2c.tga                     
-materials/textures/bar2.tga                      
-materials/textures/bigflame.tga                  
-materials/textures/bigflare1.tga                 
-materials/textures/can.tga                       
+materials/textures/backGround.png                
+materials/textures/backlightflare.png            
+materials/textures/backlighttrail.png            
+materials/textures/bar1.png                      
+materials/textures/bar2a.png                     
+materials/textures/bar2b.png                     
+materials/textures/bar2c.png                     
+materials/textures/bar2.png                      
+materials/textures/bigflame.png                  
+materials/textures/bigflare1.png                 
+materials/textures/can.png                       
 materials/textures/CockpitGlass.jpg              
 materials/textures/CockpitNose.jpg               
 materials/textures/CockpitSide.png               
-materials/textures/console2.tga                  
-materials/textures/console3.tga                  
-materials/textures/console4.tga                  
-materials/textures/console5.tga                  
-materials/textures/crate.tga                     
-materials/textures/crosshair2.tga                
-materials/textures/crosshair.tga                 
+materials/textures/console2.png                  
+materials/textures/console3.png                  
+materials/textures/console4.png                  
+materials/textures/console5.png                  
+materials/textures/crate.png                     
+materials/textures/crosshair2.png                
+materials/textures/crosshair.png                 
 materials/textures/CuboidConnectionBodySide.jpg  
 materials/textures/CuboidConnectionBodyTop.jpg   
-materials/textures/cursor_console.tga            
-materials/textures/cursor.tga                    
+materials/textures/cursor_console.png            
+materials/textures/cursor.png                    
 materials/textures/decal.jpg                     
 materials/textures/dirt01.jpg              
 materials/textures/Dirt.jpg                
 materials/textures/dish.jpg                
-materials/textures/drone.tga               
+materials/textures/drone.png               
 materials/textures/DuBall1.jpg             
 materials/textures/DuBall2.jpg             
-materials/textures/explosion3.tga          
-materials/textures/explosion.tga           
-materials/textures/final_gold.tga          
-materials/textures/flare2_1.tga            
-materials/textures/flare2.tga              
-materials/textures/flare.tga               
-materials/textures/flaretrail.tga          
+materials/textures/explosion3.png          
+materials/textures/explosion.png           
+materials/textures/final_gold.png          
+materials/textures/flare2_1.png            
+materials/textures/flare2.png              
+materials/textures/flare.png               
+materials/textures/flaretrail.png          
 materials/textures/glass01.jpg             
 materials/textures/glass02.jpg             
 materials/textures/GLX_icon.png            
-materials/textures/GLX_icon.tga            
 materials/textures/goldwrenchpickup.jpg    
 materials/textures/GreenSkin.jpg           
-materials/textures/healthbar_bar.tga       
-materials/textures/healthbar_bg.tga        
-materials/textures/hs-w01s.tga             
-materials/textures/hs-w01.tga              
-materials/textures/iceplanet.tga           
+materials/textures/healthbar_bar.png       
+materials/textures/healthbar_bg.png        
+materials/textures/hs-w01s.png             
+materials/textures/hs-w01.png              
+materials/textures/iceplanet.png           
 materials/textures/io.jpg                  
 materials/textures/jumpturbinepickup.jpg   
 materials/textures/jupiter.jpg             
-materials/textures/jupiter.tga             
-materials/textures/laserbeam.tga           
-materials/textures/LightningBall_1.tga     
-materials/textures/LightningBall_2.tga     
-materials/textures/LightningBall_3.tga     
-materials/textures/LightningBall_4.tga     
-materials/textures/LightningBall_5.tga     
-materials/textures/LightningBall_6.tga     
-materials/textures/LightningBall_7.tga     
-materials/textures/LightningBall_8.tga     
-materials/textures/Lightning_gun4.tga      
-materials/textures/Lightning_gun_pic2.tga  
-materials/textures/LightningGun.tga        
+materials/textures/jupiter.png             
+materials/textures/laserbeam.png           
+materials/textures/LightningBall_1.png     
+materials/textures/LightningBall_2.png     
+materials/textures/LightningBall_3.png     
+materials/textures/LightningBall_4.png     
+materials/textures/LightningBall_5.png     
+materials/textures/LightningBall_6.png     
+materials/textures/LightningBall_7.png     
+materials/textures/LightningBall_8.png     
+materials/textures/Lightning_gun4.png      
+materials/textures/Lightning_gun_pic2.png  
+materials/textures/LightningGun.png        
 materials/textures/main_menu_1.jpg         
-materials/textures/mapgrid.tga             
+materials/textures/mapgrid.png             
 materials/textures/MetalEdge.jpg           
 materials/textures/ogrelogo-small.jpg      
-materials/textures/ogrelogo.tga            
-materials/textures/OrxonoxBlack.tga
-materials/textures/OrxonoxGREEN.tga        
+materials/textures/ogrelogo.png            
+materials/textures/OrxonoxBlack.png
+materials/textures/OrxonoxGREEN.png        
 materials/textures/orxonox_logo.svg        
-materials/textures/OrxonoxORANGE.tga       
-materials/textures/OrxonoxRED.tga          
-materials/textures/OrxonoxYELLOW.tga       
+materials/textures/OrxonoxORANGE.png       
+materials/textures/OrxonoxRED.png          
+materials/textures/OrxonoxYELLOW.png       
 materials/textures/pirate.jpg              
 materials/textures/planet.jpg              
-materials/textures/RadarDot.tga            
-materials/textures/RadarSquare.tga         
-materials/textures/radar.tga               
-materials/textures/RadarTriangle.tga       
-materials/textures/ring_flare2.tga         
-materials/textures/ring_flare.tga          
-materials/textures/rock.tga                
-materials/textures/rust.tga                
+materials/textures/RadarDot.png            
+materials/textures/RadarSquare.png         
+materials/textures/radar.png               
+materials/textures/RadarTriangle.png       
+materials/textures/ring_flare2.png         
+materials/textures/ring_flare.png          
+materials/textures/rock.png                
+materials/textures/rust.png                
 materials/textures/RustySteel.jpg          
 materials/textures/sample_loading.jpg      
-materials/textures/Sepia1D.tga             
+materials/textures/Sepia1D.png             
 materials/textures/sewer_001.png           
 materials/textures/skypanoramagen1_bk.jpg  
@@ -314,13 +313,13 @@
 materials/textures/sl_organic04.jpg
 materials/textures/sl_panel.jpg
-materials/textures/smoke2.tga
-materials/textures/smoke3.tga
-materials/textures/smokecolors.tga
-materials/textures/smoke.tga
+materials/textures/smoke2.png
+materials/textures/smoke3.png
+materials/textures/smokecolors.png
+materials/textures/smoke.png
 materials/textures/snowyWhite.jpg
 materials/textures/spacecruiser_16.jpg
 materials/textures/SpaceShipTransporter036_engine.jpg
 materials/textures/SpaceShipTransporter036_newtexture.jpg   
-materials/textures/spacesruiser.tga
+materials/textures/spacesruiser.png
 materials/textures/starbox_bk.jpg
 materials/textures/starbox_dn.jpg
@@ -329,9 +328,9 @@
 materials/textures/starbox_rt.jpg
 materials/textures/starbox_up.jpg
-materials/textures/starship.tga
-materials/textures/streak.tga
-materials/textures/tdc.tga
+materials/textures/starship.png
+materials/textures/streak.png
+materials/textures/tdc.png
 materials/textures/thrust.jpg
 materials/textures/tiled_floor.jpg
 materials/textures/wall01.jpg
-materials/textures/white.tga
+materials/textures/white.png