Index: /code/branches/gamestates2/data/gui/scripts/AudioMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/AudioMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/AudioMenu.lua	(revision 6704)
@@ -169,5 +169,5 @@
 
 function P.AudioBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 
Index: /code/branches/gamestates2/data/gui/scripts/BasicGUI.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/BasicGUI.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/BasicGUI.lua	(revision 6704)
@@ -8,7 +8,7 @@
 
 -- constructor of the GUI
-function P:new(_filename, _gui, _visible)
+function P:new(_name, _gui, _visible)
     local newElement = {
-        filename = _filename,
+        name = _name,
         gui = _gui,
         visible = _visible or false
@@ -25,7 +25,7 @@
 -- Override this function if you want to change one of the three input parameters:
 -- showCursor = true, useKeyboard = true and blockJoyStick = false
--- But don't forget to stick to the naming convention ("GUI_" .. self.filename)
+-- But don't forget to stick to the naming convention ("GUI_" .. self.name)
 function P:createInputState()
-    self.inputState = guiMgr:createInputState("GUI_" .. self.filename)
+    self.inputState = guiMgr:createInputState("GUI_" .. self.name)
 end
 
@@ -43,5 +43,5 @@
 
 function P:load()
-    self.window = winMgr:loadWindowLayout(self.filename .. ".layout")
+    self.window = winMgr:loadWindowLayout(self.name .. ".layout")
     self:createInputState()
     self:init()
Index: /code/branches/gamestates2/data/gui/scripts/ControlsMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/ControlsMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/ControlsMenu.lua	(revision 6704)
@@ -12,5 +12,5 @@
 
 function P.ControlsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 
Index: /code/branches/gamestates2/data/gui/scripts/CreditsMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/CreditsMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/CreditsMenu.lua	(revision 6704)
@@ -4,5 +4,5 @@
 
 function P.CreditsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 
Index: /code/branches/gamestates2/data/gui/scripts/GameplayMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/GameplayMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/GameplayMenu.lua	(revision 6704)
@@ -37,5 +37,5 @@
 
 function P.GameplayBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 
Index: /code/branches/gamestates2/data/gui/scripts/GraphicsMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/GraphicsMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/GraphicsMenu.lua	(revision 6704)
@@ -192,5 +192,5 @@
 
 function P.GraphicsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 
Index: /code/branches/gamestates2/data/gui/scripts/InfoPopup.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/InfoPopup.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/InfoPopup.lua	(revision 6704)
@@ -29,5 +29,5 @@
 -- events for ingamemenu
 function P.close(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 
Index: /code/branches/gamestates2/data/gui/scripts/KeyBindMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/KeyBindMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/KeyBindMenu.lua	(revision 6704)
@@ -126,5 +126,5 @@
     plus:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0.15, 0)))
     plus:setText("add")
-    orxonox.GUIManager:subscribeEventHelper(plus, "Clicked", P.filename .. ".KeyBindPlus_clicked")
+    orxonox.GUIManager:subscribeEventHelper(plus, "Clicked", P.name .. ".KeyBindPlus_clicked")
     line:addChildWindow(plus)
     offset = offset + addWidth + spaceWidth
@@ -141,6 +141,6 @@
         button:setSize(CEGUI.UVector2(CEGUI.UDim(0, buttonWidth), CEGUI.UDim(0.7, 0)))
         button:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0.15, 0)))
-        orxonox.GUIManager:subscribeEventHelper(button, "Clicked", P.filename .. ".KeyBindButton_clicked")
-        --button:subscribeScriptedEvent("EventClicked", P.filename .. ".KeyBindButton_clicked")
+        orxonox.GUIManager:subscribeEventHelper(button, "Clicked", P.name .. ".KeyBindButton_clicked")
+        --button:subscribeScriptedEvent("EventClicked", P.name .. ".KeyBindButton_clicked")
         line:addChildWindow(button)
         offset = offset + buttonWidth
@@ -150,5 +150,5 @@
         clear:setPosition(CEGUI.UVector2(CEGUI.UDim(0, offset), CEGUI.UDim(0.15, 0)))
         clear:setText("X")
-        orxonox.GUIManager:subscribeEventHelper(clear, "Clicked", P.filename .. ".KeyBindClear_clicked")
+        orxonox.GUIManager:subscribeEventHelper(clear, "Clicked", P.name .. ".KeyBindClear_clicked")
         line:addChildWindow(clear)
         offset = offset + clearWidth + spaceWidth
Index: /code/branches/gamestates2/data/gui/scripts/MouseControlsMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/MouseControlsMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/MouseControlsMenu.lua	(revision 6704)
@@ -95,5 +95,5 @@
 
 function P.MouseControlsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 
Index: /code/branches/gamestates2/data/gui/scripts/MultiplayerMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/MultiplayerMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/MultiplayerMenu.lua	(revision 6704)
@@ -67,5 +67,5 @@
 
 function P.MultiplayerBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 
Index: /code/branches/gamestates2/data/gui/scripts/MultiplayerOptionsMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/MultiplayerOptionsMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/MultiplayerOptionsMenu.lua	(revision 6704)
@@ -4,5 +4,5 @@
 
 function P.MultiplayerOptionsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 
Index: /code/branches/gamestates2/data/gui/scripts/QuestGUI.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/QuestGUI.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/QuestGUI.lua	(revision 6704)
@@ -11,5 +11,5 @@
     local questsList = winMgr:getWindow("orxonox/QuestGUI/QuestsList")
 
-    local window = questManager:getQuestGUI(P.filename)
+    local window = questManager:getQuestGUI(P.name)
 
     questsList:addChildWindow(window)
Index: /code/branches/gamestates2/data/gui/scripts/SettingsMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/SettingsMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/SettingsMenu.lua	(revision 6704)
@@ -29,5 +29,5 @@
 
 function P.SettingsBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 
Index: /code/branches/gamestates2/data/gui/scripts/SingleplayerMenu.lua
===================================================================
--- /code/branches/gamestates2/data/gui/scripts/SingleplayerMenu.lua	(revision 6703)
+++ /code/branches/gamestates2/data/gui/scripts/SingleplayerMenu.lua	(revision 6704)
@@ -39,5 +39,5 @@
 
 function P.SingleplayerBackButton_clicked(e)
-    hideGUI(P.filename)
+    hideGUI(P.name)
 end
 